<template>
  <ObForm
    ok-text="Опубликовать"
    :form-data="formData"
    :form-model="formModel"
    @submit="onSubmit"
  >
    <ObAlert
      icon="info"
      class="add-comment-alert"
      :hide-close-button="true"
    >
      Учтите, комментарий увидят все участники тендера.
      Не указывайте ваши контактные данные или любую важную
      информацию по конкретному поставщику в тексте комментария.
    </ObAlert>

    <ObTextarea
      label="Ваш комментарий"
      placeholder="Введите текст"
      v-model="formData.commentText"
    />
  </ObForm>
</template>

<script>
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObTextarea from 'common-components/src/obComponents/obTextarea'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import { required } from 'vuelidate/lib/validators'
  import { uuid } from 'vue-uuid'
  import api from '@/api'

  export default {
    name: 'tender-tab-buyer-topics-add-modal',
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObAlert,
      ObTextarea
    },
    props: {
      tenderUuid: {
        type: String,
        required: true
      },
      topicUuid: {
        type: String,
        required: true
      }
    },
    computed: {
      formModel () {
        return {
          commentText: {
            validator: {
              required
            }
          }
        }
      }
    },
    methods: {
      async onSubmit () {
        try {
          await api.tenders.addComment(this.tenderUuid,{
            topicUuid: this.topicUuid,
            replyUuid: uuid.v4(),
            replyText: this.formData.commentText
          })

          this.$emit('submit')

          this.$notification({
            type: 'system_notification_success',
            message: 'Комментарий успешно добавлен'
          })
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка добавления комментария'
          })
        }
      }
    }
  }
</script>

<style scoped>
  .add-comment-alert {
    margin-bottom: 30px;
  }
</style>
